asteris-llc/converge

View on GitHub

Quote this to prevent word splitting.
Open

SRC_DIRS=$(find $(realpath .) -type d -maxdepth 1 -not -ipath '*/vendor' -not -ipath '*/.git' -not -ipath $(realpath .))
Severity: Minor
Found in check_license.sh by shellcheck

Quote this to prevent word splitting

Problematic code:

ls -l $(getfilename)

Correct code:

# getfilename outputs 1 file
ls -l "$(getfilename)"

# getfilename outputs multiple files, linefeed separated
getfilename | while IFS='' read -r line
do
  ls -l "$line"
done

Rationale:

When command expansions are unquoted, word splitting and globbing will occur. This often manifests itself by breaking when filenames contain spaces.

Trying to fix it by adding quotes or escapes to the data will not work. Instead, quote the command substitution itself.

If the command substitution outputs multiple pieces of data, use a loop instead.

Exceptions

In rare cases you actually want word splitting, such as in

gcc $(pkg-config --libs openssl) client.c

This is because pkg-config outputs -lssl -lcrypto, which you want to break up by spaces into -lssl and -lcrypto. An alternative is to put the variables to an array and expand it:

args=( $(pkg-config --libs openssl) )
gcc "${args[@]}" client.c

The power of using an array becomes evident when you want to combine, for example, the command result with user-provided arguments:

compile () {
    args=( $(pkg-config --libs openssl) "${@}" )
    gcc "${args[@]}" client.c
}
compile -DDEBUG
+ gcc -lssl -lcrypto -DDEBUG client.c

Notice

Original content from the ShellCheck https://github.com/koalaman/shellcheck/wiki.

Quote this to prevent word splitting.
Open

SRC_DIRS=$(find $(realpath .) -type d -maxdepth 1 -not -ipath '*/vendor' -not -ipath '*/.git' -not -ipath $(realpath .))
Severity: Minor
Found in check_license.sh by shellcheck

Quote this to prevent word splitting

Problematic code:

ls -l $(getfilename)

Correct code:

# getfilename outputs 1 file
ls -l "$(getfilename)"

# getfilename outputs multiple files, linefeed separated
getfilename | while IFS='' read -r line
do
  ls -l "$line"
done

Rationale:

When command expansions are unquoted, word splitting and globbing will occur. This often manifests itself by breaking when filenames contain spaces.

Trying to fix it by adding quotes or escapes to the data will not work. Instead, quote the command substitution itself.

If the command substitution outputs multiple pieces of data, use a loop instead.

Exceptions

In rare cases you actually want word splitting, such as in

gcc $(pkg-config --libs openssl) client.c

This is because pkg-config outputs -lssl -lcrypto, which you want to break up by spaces into -lssl and -lcrypto. An alternative is to put the variables to an array and expand it:

args=( $(pkg-config --libs openssl) )
gcc "${args[@]}" client.c

The power of using an array becomes evident when you want to combine, for example, the command result with user-provided arguments:

compile () {
    args=( $(pkg-config --libs openssl) "${@}" )
    gcc "${args[@]}" client.c
}
compile -DDEBUG
+ gcc -lssl -lcrypto -DDEBUG client.c

Notice

Original content from the ShellCheck https://github.com/koalaman/shellcheck/wiki.

Double quote to prevent globbing and word splitting.
Open

FILES=$(find ${SRC_DIRS} -type f -name '*.go')
Severity: Minor
Found in check_license.sh by shellcheck

Double quote to prevent globbing and word splitting.

Problematic code:

sh echo $1 for i in $*; do :; done # this done and the next one also applies to expanding arrays. for i in $@; do :; done

Correct code:

sh echo "$1" for i in "$@"; do :; done # or, 'for i; do'

Rationale

The first code looks like "print the first argument". It's actually "Split the first argument by IFS (spaces, tabs and line feeds). Expand each of them as if it was a glob. Join all the resulting strings and filenames with spaces. Print the result."

The second one looks like "iterate through all arguments". It's actually "join all the arguments by the first character of IFS (space), split them by IFS and expand each of them as globs, and iterate on the resulting list". The third one skips the joining part.

Quoting variables prevents word splitting and glob expansion, and prevents the script from breaking when input contains spaces, line feeds, glob characters and such.

Strictly speaking, only expansions themselves need to be quoted, but for stylistic reasons, entire arguments with multiple variable and literal parts are often quoted as one:

sh $HOME/$dir/dist/bin/$file # Unquoted (bad) "$HOME"/"$dir"/dist/bin/"$file" # Minimal quoting (good) "$HOME/$dir/dist/bin/$file" # Canonical quoting (good)

When quoting composite arguments, make sure to exclude globs and brace expansions, which lose their special meaning in double quotes: "$HOME/$dir/src/*.c" will not expand, but "$HOME/$dir/src"/*.c will.

Note that $( ) starts a new context, and variables in it have to be quoted independently:

sh echo "This $variable is quoted $(but this $variable is not)" echo "This $variable is quoted $(and now this "$variable" is too)"

Exceptions

Sometimes you want to split on spaces, like when building a command line:

sh options="-j 5 -B" make $options file

Just quoting this doesn't work. Instead, you should have used an array (bash, ksh, zsh):

bash options=(-j 5 -B) # ksh: set -A options -- -j 5 -B make "${options[@]}" file

or a function (POSIX):

sh make_with_flags() { make -j 5 -B "$@"; } make_with_flags file

To split on spaces but not perform glob expansion, Posix has a set -f to disable globbing. You can disable word splitting by setting IFS=''.

Similarly, you might want an optional argument:

sh debug="" [[ $1 == "--trace-commands" ]] && debug="-x" bash $debug script

Quoting this doesn't work, since in the default case, "$debug" would expand to one empty argument while $debug would expand into zero arguments. In this case, you can use an array with zero or one elements as outlined above, or you can use an unquoted expansion with an alternate value:

sh debug="" [[ $1 == "--trace-commands" ]] && debug="yes" bash ${debug:+"-x"} script

This is better than an unquoted value because the alternative value can be properly quoted, e.g. wget ${output:+ -o "$output"}.


As always, this warning can be [[ignore]]d on a case-by-case basis.

this is especially relevant when BASH many not be available for the array work around. For example, use in eval or in command options where script has total control of the variables...

```sh FLAGS="-av -e 'ssh -x' --delete --delete-excluded" ...

shellcheck disable=SC2086

eval rsync $FLAGS ~/dir remote_host:dir ```

Notice

Original content from the ShellCheck https://github.com/koalaman/shellcheck/wiki.

Double quote to prevent globbing and word splitting.
Open

    diff <(head -n ${HEADER_LEN} $i) <(echo "${LICENSE_HEADER}") > /dev/null
Severity: Minor
Found in check_license.sh by shellcheck

Double quote to prevent globbing and word splitting.

Problematic code:

sh echo $1 for i in $*; do :; done # this done and the next one also applies to expanding arrays. for i in $@; do :; done

Correct code:

sh echo "$1" for i in "$@"; do :; done # or, 'for i; do'

Rationale

The first code looks like "print the first argument". It's actually "Split the first argument by IFS (spaces, tabs and line feeds). Expand each of them as if it was a glob. Join all the resulting strings and filenames with spaces. Print the result."

The second one looks like "iterate through all arguments". It's actually "join all the arguments by the first character of IFS (space), split them by IFS and expand each of them as globs, and iterate on the resulting list". The third one skips the joining part.

Quoting variables prevents word splitting and glob expansion, and prevents the script from breaking when input contains spaces, line feeds, glob characters and such.

Strictly speaking, only expansions themselves need to be quoted, but for stylistic reasons, entire arguments with multiple variable and literal parts are often quoted as one:

sh $HOME/$dir/dist/bin/$file # Unquoted (bad) "$HOME"/"$dir"/dist/bin/"$file" # Minimal quoting (good) "$HOME/$dir/dist/bin/$file" # Canonical quoting (good)

When quoting composite arguments, make sure to exclude globs and brace expansions, which lose their special meaning in double quotes: "$HOME/$dir/src/*.c" will not expand, but "$HOME/$dir/src"/*.c will.

Note that $( ) starts a new context, and variables in it have to be quoted independently:

sh echo "This $variable is quoted $(but this $variable is not)" echo "This $variable is quoted $(and now this "$variable" is too)"

Exceptions

Sometimes you want to split on spaces, like when building a command line:

sh options="-j 5 -B" make $options file

Just quoting this doesn't work. Instead, you should have used an array (bash, ksh, zsh):

bash options=(-j 5 -B) # ksh: set -A options -- -j 5 -B make "${options[@]}" file

or a function (POSIX):

sh make_with_flags() { make -j 5 -B "$@"; } make_with_flags file

To split on spaces but not perform glob expansion, Posix has a set -f to disable globbing. You can disable word splitting by setting IFS=''.

Similarly, you might want an optional argument:

sh debug="" [[ $1 == "--trace-commands" ]] && debug="-x" bash $debug script

Quoting this doesn't work, since in the default case, "$debug" would expand to one empty argument while $debug would expand into zero arguments. In this case, you can use an array with zero or one elements as outlined above, or you can use an unquoted expansion with an alternate value:

sh debug="" [[ $1 == "--trace-commands" ]] && debug="yes" bash ${debug:+"-x"} script

This is better than an unquoted value because the alternative value can be properly quoted, e.g. wget ${output:+ -o "$output"}.


As always, this warning can be [[ignore]]d on a case-by-case basis.

this is especially relevant when BASH many not be available for the array work around. For example, use in eval or in command options where script has total control of the variables...

```sh FLAGS="-av -e 'ssh -x' --delete --delete-excluded" ...

shellcheck disable=SC2086

eval rsync $FLAGS ~/dir remote_host:dir ```

Notice

Original content from the ShellCheck https://github.com/koalaman/shellcheck/wiki.

Double quote to prevent globbing and word splitting.
Open

    diff <(head -n ${HEADER_LEN} $i) <(echo "${LICENSE_HEADER}") > /dev/null
Severity: Minor
Found in check_license.sh by shellcheck

Double quote to prevent globbing and word splitting.

Problematic code:

sh echo $1 for i in $*; do :; done # this done and the next one also applies to expanding arrays. for i in $@; do :; done

Correct code:

sh echo "$1" for i in "$@"; do :; done # or, 'for i; do'

Rationale

The first code looks like "print the first argument". It's actually "Split the first argument by IFS (spaces, tabs and line feeds). Expand each of them as if it was a glob. Join all the resulting strings and filenames with spaces. Print the result."

The second one looks like "iterate through all arguments". It's actually "join all the arguments by the first character of IFS (space), split them by IFS and expand each of them as globs, and iterate on the resulting list". The third one skips the joining part.

Quoting variables prevents word splitting and glob expansion, and prevents the script from breaking when input contains spaces, line feeds, glob characters and such.

Strictly speaking, only expansions themselves need to be quoted, but for stylistic reasons, entire arguments with multiple variable and literal parts are often quoted as one:

sh $HOME/$dir/dist/bin/$file # Unquoted (bad) "$HOME"/"$dir"/dist/bin/"$file" # Minimal quoting (good) "$HOME/$dir/dist/bin/$file" # Canonical quoting (good)

When quoting composite arguments, make sure to exclude globs and brace expansions, which lose their special meaning in double quotes: "$HOME/$dir/src/*.c" will not expand, but "$HOME/$dir/src"/*.c will.

Note that $( ) starts a new context, and variables in it have to be quoted independently:

sh echo "This $variable is quoted $(but this $variable is not)" echo "This $variable is quoted $(and now this "$variable" is too)"

Exceptions

Sometimes you want to split on spaces, like when building a command line:

sh options="-j 5 -B" make $options file

Just quoting this doesn't work. Instead, you should have used an array (bash, ksh, zsh):

bash options=(-j 5 -B) # ksh: set -A options -- -j 5 -B make "${options[@]}" file

or a function (POSIX):

sh make_with_flags() { make -j 5 -B "$@"; } make_with_flags file

To split on spaces but not perform glob expansion, Posix has a set -f to disable globbing. You can disable word splitting by setting IFS=''.

Similarly, you might want an optional argument:

sh debug="" [[ $1 == "--trace-commands" ]] && debug="-x" bash $debug script

Quoting this doesn't work, since in the default case, "$debug" would expand to one empty argument while $debug would expand into zero arguments. In this case, you can use an array with zero or one elements as outlined above, or you can use an unquoted expansion with an alternate value:

sh debug="" [[ $1 == "--trace-commands" ]] && debug="yes" bash ${debug:+"-x"} script

This is better than an unquoted value because the alternative value can be properly quoted, e.g. wget ${output:+ -o "$output"}.


As always, this warning can be [[ignore]]d on a case-by-case basis.

this is especially relevant when BASH many not be available for the array work around. For example, use in eval or in command options where script has total control of the variables...

```sh FLAGS="-av -e 'ssh -x' --delete --delete-excluded" ...

shellcheck disable=SC2086

eval rsync $FLAGS ~/dir remote_host:dir ```

Notice

Original content from the ShellCheck https://github.com/koalaman/shellcheck/wiki.

Check exit code directly with e.g. 'if mycmd;', not indirectly with $?.
Open

    if [[ $? -ne 0 ]]; then
Severity: Minor
Found in check_license.sh by shellcheck

Check exit code directly with e.g. 'if mycmd;', not indirectly with $?.

Problematic code:

```sh make mytarget

if [ $? -ne 0 ] then echo "Build failed" fi ```

Correct code:

sh if ! make mytarget then echo "Build failed" fi

Rationale:

Running a command and then checking its exit status $? against 0 is redundant.

Instead of just checking the exit code of a command, it checks the exit code of a command (e.g. [) that checks the exit code of a command.

Apart from the redundancy, there are other reasons to avoid this pattern:

  • Since the command and its status test are decoupled, inserting an innocent command like echo "make finished" after make will cause the if statement to silently start comparing echo's status instead.
  • Scripts that run or are called with set -e aka errexit will exit immediately if the command fails, even though they're followed by a clause that handles failure.
  • The value of $? is overwritten by [/[[, so you can't get the original value in the relevant then/else block (e.g. if mycmd; then echo "Success"; else echo "Failed with $?"; fi).

To check that a command returns success, use if mycommand; then ....

To check that a command returns failure, use if ! mycommand; then ....

To additionally capture output with command substitution: if output=$(mycommand); then ...

This also applies to while/until loops.

Exceptions:

The default Solaris 10 bourne shell does not support '!' outside of the test command (if ! mycommand; then ... returns !: not found)

Notice

Original content from the ShellCheck https://github.com/koalaman/shellcheck/wiki.

Double quote to prevent globbing and word splitting.
Open

        echo $i
Severity: Minor
Found in check_license.sh by shellcheck

Double quote to prevent globbing and word splitting.

Problematic code:

sh echo $1 for i in $*; do :; done # this done and the next one also applies to expanding arrays. for i in $@; do :; done

Correct code:

sh echo "$1" for i in "$@"; do :; done # or, 'for i; do'

Rationale

The first code looks like "print the first argument". It's actually "Split the first argument by IFS (spaces, tabs and line feeds). Expand each of them as if it was a glob. Join all the resulting strings and filenames with spaces. Print the result."

The second one looks like "iterate through all arguments". It's actually "join all the arguments by the first character of IFS (space), split them by IFS and expand each of them as globs, and iterate on the resulting list". The third one skips the joining part.

Quoting variables prevents word splitting and glob expansion, and prevents the script from breaking when input contains spaces, line feeds, glob characters and such.

Strictly speaking, only expansions themselves need to be quoted, but for stylistic reasons, entire arguments with multiple variable and literal parts are often quoted as one:

sh $HOME/$dir/dist/bin/$file # Unquoted (bad) "$HOME"/"$dir"/dist/bin/"$file" # Minimal quoting (good) "$HOME/$dir/dist/bin/$file" # Canonical quoting (good)

When quoting composite arguments, make sure to exclude globs and brace expansions, which lose their special meaning in double quotes: "$HOME/$dir/src/*.c" will not expand, but "$HOME/$dir/src"/*.c will.

Note that $( ) starts a new context, and variables in it have to be quoted independently:

sh echo "This $variable is quoted $(but this $variable is not)" echo "This $variable is quoted $(and now this "$variable" is too)"

Exceptions

Sometimes you want to split on spaces, like when building a command line:

sh options="-j 5 -B" make $options file

Just quoting this doesn't work. Instead, you should have used an array (bash, ksh, zsh):

bash options=(-j 5 -B) # ksh: set -A options -- -j 5 -B make "${options[@]}" file

or a function (POSIX):

sh make_with_flags() { make -j 5 -B "$@"; } make_with_flags file

To split on spaces but not perform glob expansion, Posix has a set -f to disable globbing. You can disable word splitting by setting IFS=''.

Similarly, you might want an optional argument:

sh debug="" [[ $1 == "--trace-commands" ]] && debug="-x" bash $debug script

Quoting this doesn't work, since in the default case, "$debug" would expand to one empty argument while $debug would expand into zero arguments. In this case, you can use an array with zero or one elements as outlined above, or you can use an unquoted expansion with an alternate value:

sh debug="" [[ $1 == "--trace-commands" ]] && debug="yes" bash ${debug:+"-x"} script

This is better than an unquoted value because the alternative value can be properly quoted, e.g. wget ${output:+ -o "$output"}.


As always, this warning can be [[ignore]]d on a case-by-case basis.

this is especially relevant when BASH many not be available for the array work around. For example, use in eval or in command options where script has total control of the variables...

```sh FLAGS="-av -e 'ssh -x' --delete --delete-excluded" ...

shellcheck disable=SC2086

eval rsync $FLAGS ~/dir remote_host:dir ```

Notice

Original content from the ShellCheck https://github.com/koalaman/shellcheck/wiki.

tempfile is deprecated. Use mktemp instead.
Open

TMPFILE=$(tempfile -s '.go')

tempfile is deprecated. Use mktemp instead.

Problematic code:

sh tmp=$(tempfile)

Correct code:

sh tmp=$(mktemp)

Rationale:

tempfile is a Debian specific utility for creating temporary files. Its man page notes:

tempfile is deprecated; you should use mktemp(1) instead.

Neither tempfile nor mktemp are POSIX, but tempfile is Debian specific while mktemp works on GNU, OSX, BusyBox, *BSD and Solaris.

Exceptions:

ShellCheck will not recognize when a function overrides this name.

Notice

Original content from the ShellCheck https://github.com/koalaman/shellcheck/wiki.

Check exit code directly with e.g. 'if mycmd;', not indirectly with $?.
Open

    if [ "$?" -eq 0 ]; then
Severity: Minor
Found in install-converge.sh by shellcheck

Check exit code directly with e.g. 'if mycmd;', not indirectly with $?.

Problematic code:

```sh make mytarget

if [ $? -ne 0 ] then echo "Build failed" fi ```

Correct code:

sh if ! make mytarget then echo "Build failed" fi

Rationale:

Running a command and then checking its exit status $? against 0 is redundant.

Instead of just checking the exit code of a command, it checks the exit code of a command (e.g. [) that checks the exit code of a command.

Apart from the redundancy, there are other reasons to avoid this pattern:

  • Since the command and its status test are decoupled, inserting an innocent command like echo "make finished" after make will cause the if statement to silently start comparing echo's status instead.
  • Scripts that run or are called with set -e aka errexit will exit immediately if the command fails, even though they're followed by a clause that handles failure.
  • The value of $? is overwritten by [/[[, so you can't get the original value in the relevant then/else block (e.g. if mycmd; then echo "Success"; else echo "Failed with $?"; fi).

To check that a command returns success, use if mycommand; then ....

To check that a command returns failure, use if ! mycommand; then ....

To additionally capture output with command substitution: if output=$(mycommand); then ...

This also applies to while/until loops.

Exceptions:

The default Solaris 10 bourne shell does not support '!' outside of the test command (if ! mycommand; then ... returns !: not found)

Notice

Original content from the ShellCheck https://github.com/koalaman/shellcheck/wiki.

Check exit code directly with e.g. 'if mycmd;', not indirectly with $?.
Open

    if [ "$?" -eq 0 ]; then
Severity: Minor
Found in install-converge.sh by shellcheck

Check exit code directly with e.g. 'if mycmd;', not indirectly with $?.

Problematic code:

```sh make mytarget

if [ $? -ne 0 ] then echo "Build failed" fi ```

Correct code:

sh if ! make mytarget then echo "Build failed" fi

Rationale:

Running a command and then checking its exit status $? against 0 is redundant.

Instead of just checking the exit code of a command, it checks the exit code of a command (e.g. [) that checks the exit code of a command.

Apart from the redundancy, there are other reasons to avoid this pattern:

  • Since the command and its status test are decoupled, inserting an innocent command like echo "make finished" after make will cause the if statement to silently start comparing echo's status instead.
  • Scripts that run or are called with set -e aka errexit will exit immediately if the command fails, even though they're followed by a clause that handles failure.
  • The value of $? is overwritten by [/[[, so you can't get the original value in the relevant then/else block (e.g. if mycmd; then echo "Success"; else echo "Failed with $?"; fi).

To check that a command returns success, use if mycommand; then ....

To check that a command returns failure, use if ! mycommand; then ....

To additionally capture output with command substitution: if output=$(mycommand); then ...

This also applies to while/until loops.

Exceptions:

The default Solaris 10 bourne shell does not support '!' outside of the test command (if ! mycommand; then ... returns !: not found)

Notice

Original content from the ShellCheck https://github.com/koalaman/shellcheck/wiki.

Check exit code directly with e.g. 'if mycmd;', not indirectly with $?.
Open

    if [ "$?" -eq 0 ]; then
Severity: Minor
Found in install-converge.sh by shellcheck

Check exit code directly with e.g. 'if mycmd;', not indirectly with $?.

Problematic code:

```sh make mytarget

if [ $? -ne 0 ] then echo "Build failed" fi ```

Correct code:

sh if ! make mytarget then echo "Build failed" fi

Rationale:

Running a command and then checking its exit status $? against 0 is redundant.

Instead of just checking the exit code of a command, it checks the exit code of a command (e.g. [) that checks the exit code of a command.

Apart from the redundancy, there are other reasons to avoid this pattern:

  • Since the command and its status test are decoupled, inserting an innocent command like echo "make finished" after make will cause the if statement to silently start comparing echo's status instead.
  • Scripts that run or are called with set -e aka errexit will exit immediately if the command fails, even though they're followed by a clause that handles failure.
  • The value of $? is overwritten by [/[[, so you can't get the original value in the relevant then/else block (e.g. if mycmd; then echo "Success"; else echo "Failed with $?"; fi).

To check that a command returns success, use if mycommand; then ....

To check that a command returns failure, use if ! mycommand; then ....

To additionally capture output with command substitution: if output=$(mycommand); then ...

This also applies to while/until loops.

Exceptions:

The default Solaris 10 bourne shell does not support '!' outside of the test command (if ! mycommand; then ... returns !: not found)

Notice

Original content from the ShellCheck https://github.com/koalaman/shellcheck/wiki.

error strings should not be capitalized or end with punctuation or a newline
Open

                    errs := fmt.Errorf("could not convert %s to time.Time any of:\n1. %v\n2. %v\n3. %v\n", name, ztErr, ltErr, stErr)
Severity: Minor
Found in resource/preparer.go by golint

error strings should not be capitalized or end with punctuation or a newline
Open

                expectedErr := fmt.Errorf("could not convert time to time.Time any of:\n1. %v\n2. %v\n3. %v\n", ztErr, ltErr, stErr)
Severity: Minor
Found in resource/preparer_test.go by golint

error strings should not be capitalized or end with punctuation or a newline
Open

                expectedErr := fmt.Errorf("could not convert time to time.Time any of:\n1. %v\n2. %v\n3. %v\n", ztErr, ltErr, stErr)
Severity: Minor
Found in resource/preparer_test.go by golint

error strings should not be capitalized or end with punctuation or a newline
Open

                expectedErr := fmt.Errorf("could not convert time to time.Time any of:\n1. %v\n2. %v\n3. %v\n", ztErr, ltErr, stErr)
Severity: Minor
Found in resource/preparer_test.go by golint

error strings should not be capitalized or end with punctuation or a newline
Open

                expectedErr := fmt.Errorf("could not convert time to time.Time any of:\n1. %v\n2. %v\n3. %v\n", ztErr, ltErr, stErr)
Severity: Minor
Found in resource/preparer_test.go by golint

func setUid should be setUID
Open

func setUid() (string, error) {
Severity: Minor
Found in resource/user/user_test.go by golint

func setFakeUid should be setFakeUID
Open

func setFakeUid() (string, error) {
Severity: Minor
Found in resource/user/user_test.go by golint

TODO found
Open

!function(e){var t="object"==typeof window&&window||"object"==typeof self&&self;"undefined"!=typeof exports?e(exports):t&&(t.hljs=e({}),"function"==typeof define&&define.amd&&define([],function(){return t.hljs}))}(function(e){function t(e){return e.replace(/[&<>]/gm,function(e){return T[e]})}function n(e){return e.nodeName.toLowerCase()}function r(e,t){var n=e&&e.exec(t);return n&&0===n.index}function a(e){return k.test(e)}function i(e){var t,n,r,i,o=e.className+" ";if(o+=e.parentNode?e.parentNode.className:"",n=y.exec(o))return w(n[1])?n[1]:"no-highlight";for(o=o.split(/\s+/),t=0,r=o.length;r>t;t++)if(i=o[t],a(i)||w(i))return i}function o(e,t){var n,r={};for(n in e)r[n]=e[n];if(t)for(n in t)r[n]=t[n];return r}function c(e){var t=[];return function r(e,a){for(var i=e.firstChild;i;i=i.nextSibling)3===i.nodeType?a+=i.nodeValue.length:1===i.nodeType&&(t.push({event:"start",offset:a,node:i}),a=r(i,a),n(i).match(/br|hr|img|input/)||t.push({event:"stop",offset:a,node:i}));return a}(e,0),t}function u(e,r,a){function i(){return e.length&&r.length?e[0].offset!==r[0].offset?e[0].offset<r[0].offset?e:r:"start"===r[0].event?e:r:e.length?e:r}function o(e){function r(e){return" "+e.nodeName+'="'+t(e.value)+'"'}l+="<"+n(e)+E.map.call(e.attributes,r).join("")+">"}function c(e){l+="</"+n(e)+">"}function u(e){("start"===e.event?o:c)(e.node)}for(var s=0,l="",f=[];e.length||r.length;){var g=i();if(l+=t(a.substring(s,g[0].offset)),s=g[0].offset,g===e){f.reverse().forEach(c);do u(g.splice(0,1)[0]),g=i();while(g===e&&g.length&&g[0].offset===s);f.reverse().forEach(o)}else"start"===g[0].event?f.push(g[0].node):f.pop(),u(g.splice(0,1)[0])}return l+t(a.substr(s))}function s(e){function t(e){return e&&e.source||e}function n(n,r){return new RegExp(t(n),"m"+(e.cI?"i":"")+(r?"g":""))}function r(a,i){if(!a.compiled){if(a.compiled=!0,a.k=a.k||a.bK,a.k){var c={},u=function(t,n){e.cI&&(n=n.toLowerCase()),n.split(" ").forEach(function(e){var n=e.split("|");c[n[0]]=[t,n[1]?Number(n[1]):1]})};"string"==typeof a.k?u("keyword",a.k):R(a.k).forEach(function(e){u(e,a.k[e])}),a.k=c}a.lR=n(a.l||/\w+/,!0),i&&(a.bK&&(a.b="\\b("+a.bK.split(" ").join("|")+")\\b"),a.b||(a.b=/\B|\b/),a.bR=n(a.b),a.e||a.eW||(a.e=/\B|\b/),a.e&&(a.eR=n(a.e)),a.tE=t(a.e)||"",a.eW&&i.tE&&(a.tE+=(a.e?"|":"")+i.tE)),a.i&&(a.iR=n(a.i)),null==a.r&&(a.r=1),a.c||(a.c=[]);var s=[];a.c.forEach(function(e){e.v?e.v.forEach(function(t){s.push(o(e,t))}):s.push("self"===e?a:e)}),a.c=s,a.c.forEach(function(e){r(e,a)}),a.starts&&r(a.starts,i);var l=a.c.map(function(e){return e.bK?"\\.?("+e.b+")\\.?":e.b}).concat([a.tE,a.i]).map(t).filter(Boolean);a.t=l.length?n(l.join("|"),!0):{exec:function(){return null}}}}r(e)}function l(e,n,a,i){function o(e,t){var n,a;for(n=0,a=t.c.length;a>n;n++)if(r(t.c[n].bR,e))return t.c[n]}function c(e,t){if(r(e.eR,t)){for(;e.endsParent&&e.parent;)e=e.parent;return e}return e.eW?c(e.parent,t):void 0}function u(e,t){return!a&&r(t.iR,e)}function g(e,t){var n=N.cI?t[0].toLowerCase():t[0];return e.k.hasOwnProperty(n)&&e.k[n]}function p(e,t,n,r){var a=r?"":B.classPrefix,i='<span class="'+a,o=n?"":M;return i+=e+'">',i+t+o}function b(){var e,n,r,a;if(!R.k)return t(y);for(a="",n=0,R.lR.lastIndex=0,r=R.lR.exec(y);r;)a+=t(y.substring(n,r.index)),e=g(R,r),e?(L+=e[1],a+=p(e[0],t(r[0]))):a+=t(r[0]),n=R.lR.lastIndex,r=R.lR.exec(y);return a+t(y.substr(n))}function d(){var e="string"==typeof R.sL;if(e&&!C[R.sL])return t(y);var n=e?l(R.sL,y,!0,x[R.sL]):f(y,R.sL.length?R.sL:void 0);return R.r>0&&(L+=n.r),e&&(x[R.sL]=n.top),p(n.language,n.value,!1,!0)}function h(){k+=null!=R.sL?d():b(),y=""}function m(e){k+=e.cN?p(e.cN,"",!0):"",R=Object.create(e,{parent:{value:R}})}function v(e,t){if(y+=e,null==t)return h(),0;var n=o(t,R);if(n)return n.skip?y+=t:(n.eB&&(y+=t),h(),n.rB||n.eB||(y=t)),m(n,t),n.rB?0:t.length;var r=c(R,t);if(r){var a=R;a.skip?y+=t:(a.rE||a.eE||(y+=t),h(),a.eE&&(y=t));do R.cN&&(k+=M),R.skip||(L+=R.r),R=R.parent;while(R!==r.parent);return r.starts&&m(r.starts,""),a.rE?0:t.length}if(u(t,R))throw new Error('Illegal lexeme "'+t+'" for mode "'+(R.cN||"<unnamed>")+'"');return y+=t,t.length||1}var N=w(e);if(!N)throw new Error('Unknown language: "'+e+'"');s(N);var E,R=i||N,x={},k="";for(E=R;E!==N;E=E.parent)E.cN&&(k=p(E.cN,"",!0)+k);var y="",L=0;try{for(var T,I,S=0;;){if(R.t.lastIndex=S,T=R.t.exec(n),!T)break;I=v(n.substring(S,T.index),T[0]),S=T.index+I}for(v(n.substr(S)),E=R;E.parent;E=E.parent)E.cN&&(k+=M);return{r:L,value:k,language:e,top:R}}catch(_){if(_.message&&-1!==_.message.indexOf("Illegal"))return{r:0,value:t(n)};throw _}}function f(e,n){n=n||B.languages||R(C);var r={r:0,value:t(e)},a=r;return n.filter(w).forEach(function(t){var n=l(t,e,!1);n.language=t,n.r>a.r&&(a=n),n.r>r.r&&(a=r,r=n)}),a.language&&(r.second_best=a),r}function g(e){return B.tabReplace||B.useBR?e.replace(L,function(e,t){return B.useBR&&"\n"===e?"<br>":B.tabReplace?t.replace(/\t/g,B.tabReplace):void 0}):e}function p(e,t,n){var r=t?x[t]:n,a=[e.trim()];return e.match(/\bhljs\b/)||a.push("hljs"),-1===e.indexOf(r)&&a.push(r),a.join(" ").trim()}function b(e){var t,n,r,o,s,b=i(e);a(b)||(B.useBR?(t=document.createElementNS("http://www.w3.org/1999/xhtml","div"),t.innerHTML=e.innerHTML.replace(/\n/g,"").replace(/<br[ \/]*>/g,"\n")):t=e,s=t.textContent,r=b?l(b,s,!0):f(s),n=c(t),n.length&&(o=document.createElementNS("http://www.w3.org/1999/xhtml","div"),o.innerHTML=r.value,r.value=u(n,c(o),s)),r.value=g(r.value),e.innerHTML=r.value,e.className=p(e.className,b,r.language),e.result={language:r.language,re:r.r},r.second_best&&(e.second_best={language:r.second_best.language,re:r.second_best.r}))}function d(e){B=o(B,e)}function h(){if(!h.called){h.called=!0;var e=document.querySelectorAll("pre code");E.forEach.call(e,b)}}function m(){addEventListener("DOMContentLoaded",h,!1),addEventListener("load",h,!1)}function v(t,n){var r=C[t]=n(e);r.aliases&&r.aliases.forEach(function(e){x[e]=t})}function N(){return R(C)}function w(e){return e=(e||"").toLowerCase(),C[e]||C[x[e]]}var E=[],R=Object.keys,C={},x={},k=/^(no-?highlight|plain|text)$/i,y=/\blang(?:uage)?-([\w-]+)\b/i,L=/((^(<[^>]+>|\t|)+|(?:\n)))/gm,M="</span>",B={classPrefix:"hljs-",tabReplace:null,useBR:!1,languages:void 0},T={"&":"&amp;","<":"&lt;",">":"&gt;"};return e.highlight=l,e.highlightAuto=f,e.fixMarkup=g,e.highlightBlock=b,e.configure=d,e.initHighlighting=h,e.initHighlightingOnLoad=m,e.registerLanguage=v,e.listLanguages=N,e.getLanguage=w,e.inherit=o,e.IR="[a-zA-Z]\\w*",e.UIR="[a-zA-Z_]\\w*",e.NR="\\b\\d+(\\.\\d+)?",e.CNR="(-?)(\\b0[xX][a-fA-F0-9]+|(\\b\\d+(\\.\\d*)?|\\.\\d+)([eE][-+]?\\d+)?)",e.BNR="\\b(0b[01]+)",e.RSR="!|!=|!==|%|%=|&|&&|&=|\\*|\\*=|\\+|\\+=|,|-|-=|/=|/|:|;|<<|<<=|<=|<|===|==|=|>>>=|>>=|>=|>>>|>>|>|\\?|\\[|\\{|\\(|\\^|\\^=|\\||\\|=|\\|\\||~",e.BE={b:"\\\\[\\s\\S]",r:0},e.ASM={cN:"string",b:"'",e:"'",i:"\\n",c:[e.BE]},e.QSM={cN:"string",b:'"',e:'"',i:"\\n",c:[e.BE]},e.PWM={b:/\b(a|an|the|are|I'm|isn't|don't|doesn't|won't|but|just|should|pretty|simply|enough|gonna|going|wtf|so|such|will|you|your|like)\b/},e.C=function(t,n,r){var a=e.inherit({cN:"comment",b:t,e:n,c:[]},r||{});return a.c.push(e.PWM),a.c.push({cN:"doctag",b:"(?:TODO|FIXME|NOTE|BUG|XXX):",r:0}),a},e.CLCM=e.C("//","$"),e.CBCM=e.C("/\\*","\\*/"),e.HCM=e.C("#","$"),e.NM={cN:"number",b:e.NR,r:0},e.CNM={cN:"number",b:e.CNR,r:0},e.BNM={cN:"number",b:e.BNR,r:0},e.CSSNM={cN:"number",b:e.NR+"(%|em|ex|ch|rem|vw|vh|vmin|vmax|cm|mm|in|pt|pc|px|deg|grad|rad|turn|s|ms|Hz|kHz|dpi|dpcm|dppx)?",r:0},e.RM={cN:"regexp",b:/\//,e:/\/[gimuy]*/,i:/\n/,c:[e.BE,{b:/\[/,e:/\]/,r:0,c:[e.BE]}]},e.TM={cN:"title",b:e.IR,r:0},e.UTM={cN:"title",b:e.UIR,r:0},e.METHOD_GUARD={b:"\\.\\s*"+e.UIR,r:0},e.registerLanguage("bash",function(e){var t={cN:"variable",v:[{b:/\$[\w\d#@][\w\d_]*/},{b:/\$\{(.*?)}/}]},n={cN:"string",b:/"/,e:/"/,c:[e.BE,t,{cN:"variable",b:/\$\(/,e:/\)/,c:[e.BE]}]},r={cN:"string",b:/'/,e:/'/};return{aliases:["sh","zsh"],l:/-?[a-z\._]+/,k:{keyword:"if then else elif fi for while in do done case esac function",literal:"true false",built_in:"break cd continue eval exec exit export getopts hash pwd readonly return shift test times trap umask unset alias bind builtin caller command declare echo enable help let local logout mapfile printf read readarray source type typeset ulimit unalias set shopt autoload bg bindkey bye cap chdir clone comparguments compcall compctl compdescribe compfiles compgroups compquote comptags comptry compvalues dirs disable disown echotc echoti emulate fc fg float functions getcap getln history integer jobs kill limit log noglob popd print pushd pushln rehash sched setcap setopt stat suspend ttyctl unfunction unhash unlimit unsetopt vared wait whence where which zcompile zformat zftp zle zmodload zparseopts zprof zpty zregexparse zsocket zstyle ztcp",_:"-ne -eq -lt -gt -f -d -e -s -l -a"},c:[{cN:"meta",b:/^#![^\n]+sh\s*$/,r:10},{cN:"function",b:/\w[\w\d_]*\s*\(\s*\)\s*\{/,rB:!0,c:[e.inherit(e.TM,{b:/\w[\w\d_]*/})],r:0},e.HCM,n,r,t]}}),e.registerLanguage("go",function(e){var t={keyword:"break default func interface select case map struct chan else goto package switch const fallthrough if range type continue for import return var go defer bool byte complex64 complex128 float32 float64 int8 int16 int32 int64 string uint8 uint16 uint32 uint64 int uint uintptr rune",literal:"true false iota nil",built_in:"append cap close complex copy imag len make new panic print println real recover delete"};return{aliases:["golang"],k:t,i:"</",c:[e.CLCM,e.CBCM,{cN:"string",v:[e.QSM,{b:"'",e:"[^\\\\]'"},{b:"`",e:"`"}]},{cN:"number",v:[{b:e.CNR+"[dflsi]",r:1},e.CNM]},{b:/:=/},{cN:"function",bK:"func",e:/\s*\{/,eE:!0,c:[e.TM,{cN:"params",b:/\(/,e:/\)/,k:t,i:/["']/}]}]}}),e.registerLanguage("hcl",function(e){return BACKTICK_STRING={cN:"string",b:/[`"]/,e:/[`"]/},KEYWORD={cN:"keyword",b:/[A-Za-z\_\.\-]+\s*/},LITERAL={cN:"literal",b:/(true|false|null)/},SUBST_CONTAINS=[e.CNM,LITERAL,BACKTICK_STRING],{aliases:["tf"],c:[e.CLCM,e.CBCM,e.HCM,e.CNM,KEYWORD,LITERAL,{cN:"string",c:[{cN:"subst",b:/\$\{/,e:/\}/,c:SUBST_CONTAINS},{cN:"subst",b:/\{\{/,e:/\}\}/,c:SUBST_CONTAINS}],v:[{b:/"/,e:/"/},{b:"<<EOF",e:"EOF"}]}]}}),e});

FIXME found
Open

!function(e){var t="object"==typeof window&&window||"object"==typeof self&&self;"undefined"!=typeof exports?e(exports):t&&(t.hljs=e({}),"function"==typeof define&&define.amd&&define([],function(){return t.hljs}))}(function(e){function t(e){return e.replace(/[&<>]/gm,function(e){return T[e]})}function n(e){return e.nodeName.toLowerCase()}function r(e,t){var n=e&&e.exec(t);return n&&0===n.index}function a(e){return k.test(e)}function i(e){var t,n,r,i,o=e.className+" ";if(o+=e.parentNode?e.parentNode.className:"",n=y.exec(o))return w(n[1])?n[1]:"no-highlight";for(o=o.split(/\s+/),t=0,r=o.length;r>t;t++)if(i=o[t],a(i)||w(i))return i}function o(e,t){var n,r={};for(n in e)r[n]=e[n];if(t)for(n in t)r[n]=t[n];return r}function c(e){var t=[];return function r(e,a){for(var i=e.firstChild;i;i=i.nextSibling)3===i.nodeType?a+=i.nodeValue.length:1===i.nodeType&&(t.push({event:"start",offset:a,node:i}),a=r(i,a),n(i).match(/br|hr|img|input/)||t.push({event:"stop",offset:a,node:i}));return a}(e,0),t}function u(e,r,a){function i(){return e.length&&r.length?e[0].offset!==r[0].offset?e[0].offset<r[0].offset?e:r:"start"===r[0].event?e:r:e.length?e:r}function o(e){function r(e){return" "+e.nodeName+'="'+t(e.value)+'"'}l+="<"+n(e)+E.map.call(e.attributes,r).join("")+">"}function c(e){l+="</"+n(e)+">"}function u(e){("start"===e.event?o:c)(e.node)}for(var s=0,l="",f=[];e.length||r.length;){var g=i();if(l+=t(a.substring(s,g[0].offset)),s=g[0].offset,g===e){f.reverse().forEach(c);do u(g.splice(0,1)[0]),g=i();while(g===e&&g.length&&g[0].offset===s);f.reverse().forEach(o)}else"start"===g[0].event?f.push(g[0].node):f.pop(),u(g.splice(0,1)[0])}return l+t(a.substr(s))}function s(e){function t(e){return e&&e.source||e}function n(n,r){return new RegExp(t(n),"m"+(e.cI?"i":"")+(r?"g":""))}function r(a,i){if(!a.compiled){if(a.compiled=!0,a.k=a.k||a.bK,a.k){var c={},u=function(t,n){e.cI&&(n=n.toLowerCase()),n.split(" ").forEach(function(e){var n=e.split("|");c[n[0]]=[t,n[1]?Number(n[1]):1]})};"string"==typeof a.k?u("keyword",a.k):R(a.k).forEach(function(e){u(e,a.k[e])}),a.k=c}a.lR=n(a.l||/\w+/,!0),i&&(a.bK&&(a.b="\\b("+a.bK.split(" ").join("|")+")\\b"),a.b||(a.b=/\B|\b/),a.bR=n(a.b),a.e||a.eW||(a.e=/\B|\b/),a.e&&(a.eR=n(a.e)),a.tE=t(a.e)||"",a.eW&&i.tE&&(a.tE+=(a.e?"|":"")+i.tE)),a.i&&(a.iR=n(a.i)),null==a.r&&(a.r=1),a.c||(a.c=[]);var s=[];a.c.forEach(function(e){e.v?e.v.forEach(function(t){s.push(o(e,t))}):s.push("self"===e?a:e)}),a.c=s,a.c.forEach(function(e){r(e,a)}),a.starts&&r(a.starts,i);var l=a.c.map(function(e){return e.bK?"\\.?("+e.b+")\\.?":e.b}).concat([a.tE,a.i]).map(t).filter(Boolean);a.t=l.length?n(l.join("|"),!0):{exec:function(){return null}}}}r(e)}function l(e,n,a,i){function o(e,t){var n,a;for(n=0,a=t.c.length;a>n;n++)if(r(t.c[n].bR,e))return t.c[n]}function c(e,t){if(r(e.eR,t)){for(;e.endsParent&&e.parent;)e=e.parent;return e}return e.eW?c(e.parent,t):void 0}function u(e,t){return!a&&r(t.iR,e)}function g(e,t){var n=N.cI?t[0].toLowerCase():t[0];return e.k.hasOwnProperty(n)&&e.k[n]}function p(e,t,n,r){var a=r?"":B.classPrefix,i='<span class="'+a,o=n?"":M;return i+=e+'">',i+t+o}function b(){var e,n,r,a;if(!R.k)return t(y);for(a="",n=0,R.lR.lastIndex=0,r=R.lR.exec(y);r;)a+=t(y.substring(n,r.index)),e=g(R,r),e?(L+=e[1],a+=p(e[0],t(r[0]))):a+=t(r[0]),n=R.lR.lastIndex,r=R.lR.exec(y);return a+t(y.substr(n))}function d(){var e="string"==typeof R.sL;if(e&&!C[R.sL])return t(y);var n=e?l(R.sL,y,!0,x[R.sL]):f(y,R.sL.length?R.sL:void 0);return R.r>0&&(L+=n.r),e&&(x[R.sL]=n.top),p(n.language,n.value,!1,!0)}function h(){k+=null!=R.sL?d():b(),y=""}function m(e){k+=e.cN?p(e.cN,"",!0):"",R=Object.create(e,{parent:{value:R}})}function v(e,t){if(y+=e,null==t)return h(),0;var n=o(t,R);if(n)return n.skip?y+=t:(n.eB&&(y+=t),h(),n.rB||n.eB||(y=t)),m(n,t),n.rB?0:t.length;var r=c(R,t);if(r){var a=R;a.skip?y+=t:(a.rE||a.eE||(y+=t),h(),a.eE&&(y=t));do R.cN&&(k+=M),R.skip||(L+=R.r),R=R.parent;while(R!==r.parent);return r.starts&&m(r.starts,""),a.rE?0:t.length}if(u(t,R))throw new Error('Illegal lexeme "'+t+'" for mode "'+(R.cN||"<unnamed>")+'"');return y+=t,t.length||1}var N=w(e);if(!N)throw new Error('Unknown language: "'+e+'"');s(N);var E,R=i||N,x={},k="";for(E=R;E!==N;E=E.parent)E.cN&&(k=p(E.cN,"",!0)+k);var y="",L=0;try{for(var T,I,S=0;;){if(R.t.lastIndex=S,T=R.t.exec(n),!T)break;I=v(n.substring(S,T.index),T[0]),S=T.index+I}for(v(n.substr(S)),E=R;E.parent;E=E.parent)E.cN&&(k+=M);return{r:L,value:k,language:e,top:R}}catch(_){if(_.message&&-1!==_.message.indexOf("Illegal"))return{r:0,value:t(n)};throw _}}function f(e,n){n=n||B.languages||R(C);var r={r:0,value:t(e)},a=r;return n.filter(w).forEach(function(t){var n=l(t,e,!1);n.language=t,n.r>a.r&&(a=n),n.r>r.r&&(a=r,r=n)}),a.language&&(r.second_best=a),r}function g(e){return B.tabReplace||B.useBR?e.replace(L,function(e,t){return B.useBR&&"\n"===e?"<br>":B.tabReplace?t.replace(/\t/g,B.tabReplace):void 0}):e}function p(e,t,n){var r=t?x[t]:n,a=[e.trim()];return e.match(/\bhljs\b/)||a.push("hljs"),-1===e.indexOf(r)&&a.push(r),a.join(" ").trim()}function b(e){var t,n,r,o,s,b=i(e);a(b)||(B.useBR?(t=document.createElementNS("http://www.w3.org/1999/xhtml","div"),t.innerHTML=e.innerHTML.replace(/\n/g,"").replace(/<br[ \/]*>/g,"\n")):t=e,s=t.textContent,r=b?l(b,s,!0):f(s),n=c(t),n.length&&(o=document.createElementNS("http://www.w3.org/1999/xhtml","div"),o.innerHTML=r.value,r.value=u(n,c(o),s)),r.value=g(r.value),e.innerHTML=r.value,e.className=p(e.className,b,r.language),e.result={language:r.language,re:r.r},r.second_best&&(e.second_best={language:r.second_best.language,re:r.second_best.r}))}function d(e){B=o(B,e)}function h(){if(!h.called){h.called=!0;var e=document.querySelectorAll("pre code");E.forEach.call(e,b)}}function m(){addEventListener("DOMContentLoaded",h,!1),addEventListener("load",h,!1)}function v(t,n){var r=C[t]=n(e);r.aliases&&r.aliases.forEach(function(e){x[e]=t})}function N(){return R(C)}function w(e){return e=(e||"").toLowerCase(),C[e]||C[x[e]]}var E=[],R=Object.keys,C={},x={},k=/^(no-?highlight|plain|text)$/i,y=/\blang(?:uage)?-([\w-]+)\b/i,L=/((^(<[^>]+>|\t|)+|(?:\n)))/gm,M="</span>",B={classPrefix:"hljs-",tabReplace:null,useBR:!1,languages:void 0},T={"&":"&amp;","<":"&lt;",">":"&gt;"};return e.highlight=l,e.highlightAuto=f,e.fixMarkup=g,e.highlightBlock=b,e.configure=d,e.initHighlighting=h,e.initHighlightingOnLoad=m,e.registerLanguage=v,e.listLanguages=N,e.getLanguage=w,e.inherit=o,e.IR="[a-zA-Z]\\w*",e.UIR="[a-zA-Z_]\\w*",e.NR="\\b\\d+(\\.\\d+)?",e.CNR="(-?)(\\b0[xX][a-fA-F0-9]+|(\\b\\d+(\\.\\d*)?|\\.\\d+)([eE][-+]?\\d+)?)",e.BNR="\\b(0b[01]+)",e.RSR="!|!=|!==|%|%=|&|&&|&=|\\*|\\*=|\\+|\\+=|,|-|-=|/=|/|:|;|<<|<<=|<=|<|===|==|=|>>>=|>>=|>=|>>>|>>|>|\\?|\\[|\\{|\\(|\\^|\\^=|\\||\\|=|\\|\\||~",e.BE={b:"\\\\[\\s\\S]",r:0},e.ASM={cN:"string",b:"'",e:"'",i:"\\n",c:[e.BE]},e.QSM={cN:"string",b:'"',e:'"',i:"\\n",c:[e.BE]},e.PWM={b:/\b(a|an|the|are|I'm|isn't|don't|doesn't|won't|but|just|should|pretty|simply|enough|gonna|going|wtf|so|such|will|you|your|like)\b/},e.C=function(t,n,r){var a=e.inherit({cN:"comment",b:t,e:n,c:[]},r||{});return a.c.push(e.PWM),a.c.push({cN:"doctag",b:"(?:TODO|FIXME|NOTE|BUG|XXX):",r:0}),a},e.CLCM=e.C("//","$"),e.CBCM=e.C("/\\*","\\*/"),e.HCM=e.C("#","$"),e.NM={cN:"number",b:e.NR,r:0},e.CNM={cN:"number",b:e.CNR,r:0},e.BNM={cN:"number",b:e.BNR,r:0},e.CSSNM={cN:"number",b:e.NR+"(%|em|ex|ch|rem|vw|vh|vmin|vmax|cm|mm|in|pt|pc|px|deg|grad|rad|turn|s|ms|Hz|kHz|dpi|dpcm|dppx)?",r:0},e.RM={cN:"regexp",b:/\//,e:/\/[gimuy]*/,i:/\n/,c:[e.BE,{b:/\[/,e:/\]/,r:0,c:[e.BE]}]},e.TM={cN:"title",b:e.IR,r:0},e.UTM={cN:"title",b:e.UIR,r:0},e.METHOD_GUARD={b:"\\.\\s*"+e.UIR,r:0},e.registerLanguage("bash",function(e){var t={cN:"variable",v:[{b:/\$[\w\d#@][\w\d_]*/},{b:/\$\{(.*?)}/}]},n={cN:"string",b:/"/,e:/"/,c:[e.BE,t,{cN:"variable",b:/\$\(/,e:/\)/,c:[e.BE]}]},r={cN:"string",b:/'/,e:/'/};return{aliases:["sh","zsh"],l:/-?[a-z\._]+/,k:{keyword:"if then else elif fi for while in do done case esac function",literal:"true false",built_in:"break cd continue eval exec exit export getopts hash pwd readonly return shift test times trap umask unset alias bind builtin caller command declare echo enable help let local logout mapfile printf read readarray source type typeset ulimit unalias set shopt autoload bg bindkey bye cap chdir clone comparguments compcall compctl compdescribe compfiles compgroups compquote comptags comptry compvalues dirs disable disown echotc echoti emulate fc fg float functions getcap getln history integer jobs kill limit log noglob popd print pushd pushln rehash sched setcap setopt stat suspend ttyctl unfunction unhash unlimit unsetopt vared wait whence where which zcompile zformat zftp zle zmodload zparseopts zprof zpty zregexparse zsocket zstyle ztcp",_:"-ne -eq -lt -gt -f -d -e -s -l -a"},c:[{cN:"meta",b:/^#![^\n]+sh\s*$/,r:10},{cN:"function",b:/\w[\w\d_]*\s*\(\s*\)\s*\{/,rB:!0,c:[e.inherit(e.TM,{b:/\w[\w\d_]*/})],r:0},e.HCM,n,r,t]}}),e.registerLanguage("go",function(e){var t={keyword:"break default func interface select case map struct chan else goto package switch const fallthrough if range type continue for import return var go defer bool byte complex64 complex128 float32 float64 int8 int16 int32 int64 string uint8 uint16 uint32 uint64 int uint uintptr rune",literal:"true false iota nil",built_in:"append cap close complex copy imag len make new panic print println real recover delete"};return{aliases:["golang"],k:t,i:"</",c:[e.CLCM,e.CBCM,{cN:"string",v:[e.QSM,{b:"'",e:"[^\\\\]'"},{b:"`",e:"`"}]},{cN:"number",v:[{b:e.CNR+"[dflsi]",r:1},e.CNM]},{b:/:=/},{cN:"function",bK:"func",e:/\s*\{/,eE:!0,c:[e.TM,{cN:"params",b:/\(/,e:/\)/,k:t,i:/["']/}]}]}}),e.registerLanguage("hcl",function(e){return BACKTICK_STRING={cN:"string",b:/[`"]/,e:/[`"]/},KEYWORD={cN:"keyword",b:/[A-Za-z\_\.\-]+\s*/},LITERAL={cN:"literal",b:/(true|false|null)/},SUBST_CONTAINS=[e.CNM,LITERAL,BACKTICK_STRING],{aliases:["tf"],c:[e.CLCM,e.CBCM,e.HCM,e.CNM,KEYWORD,LITERAL,{cN:"string",c:[{cN:"subst",b:/\$\{/,e:/\}/,c:SUBST_CONTAINS},{cN:"subst",b:/\{\{/,e:/\}\}/,c:SUBST_CONTAINS}],v:[{b:/"/,e:/"/},{b:"<<EOF",e:"EOF"}]}]}}),e});
Severity
Category
Status